routes/web.php
<?php

use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', function () {
    return view('welcome');
});

Auth::routes();

Route::get('/home', 'HomeController@index')->name('home');

Route::resource('category','CategoryController');
Route::resource('subcategory','SubCategoryController');
Route::resource('product','ProductController');
Route::resource('production','ProductionController');
Route::get('/generate_pdf', 'OrderController@generate')->name('order.generate-pdf');
Route::resource('order','OrderController');

app/Product.php
<?php

namespace App;

use Illuminate\Database\Eloquent\Model;

class Product extends Model
{
    protected $fillable = ['sub_category_id','name','price'];

    protected $table = "products";

    public function subcategory(){
        return $this->belongsTo('App\SubCategory','sub_category_id');
    }

    public function image(){
        return $this->hasMany('App\Image', 'product_id');
    }

    public function stock(){
        return $this->hasMany('App\Stock','product_id');
    }

    public function order(){
        return $this->hasMany('App\Order','product_id');
    }
}

app/Http/Controllers/ProductController.php
<?php

namespace App\Http\Controllers;

use App\Category;
use App\Image;
use App\Product;
use App\SubCategory;
use Illuminate\Http\Request;

class ProductController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        $product = Product::with('subcategory.category')->paginate(2);
        return view('product.index', compact('product'));
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        $category = Category::get();
        $subcategory = SubCategory::with('category')->get();
        return view('product.create', compact('subcategory','category'));
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        try{
            $product = new Product();
            $product->sub_category_id = $request->sub_category_id;
            $product->name = $request->name;
            $product->price = $request->price;
            $product->save();

            foreach ($request->image as $att){
                $image = new Image();
                $image->product_id = $product->id;
                $filename  = $att;
                $destpath  = "images/sample/";
                $imagename = uniqid() . "-" . $filename->getClientOriginalName();
                $filename->move($destpath, $imagename);
                $photo = $destpath . $imagename;
                $newfile = $photo;
                $image->image = $newfile;
                $image->save();
            }
            return redirect()->route('product.index');
        }
        catch (\Exception $e){
            dd($e);
        }
    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        $image = Image::where('product_id',$id)->get();
        return view('product.show', compact('image'));
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        //
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id)
    {
        //
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        //
    }
}

resources/views/product/create.blade.php
@extends('layouts.app')

@section('content')
    <div class="container">
        <div class="row justify-content-center">
            <div class="col-md-8">
                <div class="card">
                    <div class="card-header">Add Product</div>

                    <div class="card-body">
                        <form method="post" action="{{route('product.store')}}" enctype="multipart/form-data" id="form-product">
                            @csrf
                            <label>Category</label>
                            <select class="form-control" name="sub_category_id" id="category">
                                @foreach($category as $row)
                                    <option value="{{$row->id}}">{{$row->name}}</option>
                                @endforeach
                            </select>
                            <label>Sub Category</label>
                            <select class="form-control" name="sub_category_id" id="subcat">

                            </select>
                            <label>Product Name</label>
                            <input type="text" class="form-control" name="name" required>
                            <label>Price</label>
                            <input type="number" class="form-control" name="price">
                            <label>Images</label>
                            <input type="file" class="form-control" name="image[]" placeholder="images" multiple>
                            <input type="submit" name="Submit">
                        </form>

                    </div>
                </div>
            </div>
        </div>
    </div>

    <script>
        $(document).ready(function () {
            $('#category').on('change', function () {
                var vals = document.getElementById('category').value;
                $('#subcat').empty();

                <?php foreach($subcategory as $row): ?>
                    if (<?php echo $row->category->id; ?> == vals) {

                    var sel = document.getElementById('subcat');
                    // create new option element
                    var opt = document.createElement('option');

                    opt.appendChild( document.createTextNode('<?php echo $row->name ?>') );

                    opt.value = <?php echo $row->id ?>;

                    sel.appendChild(opt);
                    }
                <?php endforeach ?>
            })
        })
    </script>

@endsection

resources/views/product/index.blade.php
@extends('layouts.app')

@section('content')
    <div class="container">
        <div class="row justify-content-center">
            <div class="col-md-8">
                <div class="card">
                    <div class="card-header">Product</div>

                    <div class="card-body">
                        @if (session('status'))
                            <div class="alert alert-success" role="alert">
                                {{ session('status') }}
                            </div>
                        @endif
                        <a href="{{route('product.create')}}" class="btn btn-primary">Create Product</a>
                        <table class="table table-responsive">
                            <thead>
                            <tr>
                                <th>Product</th>
                                <th>Price</th>
                                <th>Image</th>
                            </tr>
                            </thead>
                            <tbody>
                            @foreach($product as $row)
                                <tr>
                                    <td>{{$row->name}}</td>
                                    <td>{{$row->price}}</td>
                                    <td><a href="{{route('product.show', $row->id)}}" class="btn btn-primary">See Image</a></td>
                                </tr>
                            @endforeach
                            </tbody>
                        </table>
                        {{$product->links()}}
                    </div>
                </div>
            </div>
        </div>
    </div>
@endsection

resources/views/product/show.blade.php
@extends('layouts.app')

@section('content')
    <div class="container">
        <div class="row justify-content-center">
            <div class="col-md-8">
                <div class="card">
                    <div class="card-header">Images</div>

                    <div class="card-body">
                        @foreach($image as $images)
                            <img src="{{asset($images->image)}}" style="height: 400px" class="form-control">
                        @endforeach
                    </div>
                </div>
            </div>
        </div>
    </div>
@endsection